unit Unit1;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,  CommCtrl,
  ShellAPI   // DragAcceptFiles
  ;


type
  { TMyCustomTreeView }
  TMyCustomListView = class(TCustomListView)
    private
       FActivateDropAccept: Boolean;
    protected
      procedure WndProc( var Message: TMessage ); override;
      procedure SetActivateDropAccept(Value: Boolean);
      procedure WMDropFiles(var Msg: TMessage); message WM_DROPFILES;
      procedure DoOnDropFiles(Sender: TObject;const FileNames: array of String);
    public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
    published
       property ActivateDropAccept: Boolean read FActivateDropAccept write SetActivateDropAccept default False;
    end;


type

  { TForm1 }

  TForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
  private
    { Private-Deklarationen }
  protected
    procedure WndProc( var Message: TMessage ); override;
    procedure WMDropFiles(var Msg: TMessage); message WM_DROPFILES;
  public
    MyCustomListView1 : TMyCustomListView;
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$IFnDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}

procedure TForm1.FormCreate(Sender: TObject);
begin
   MyCustomListView1 := TMyCustomListView.Create(Self);
   with MyCustomListView1 do begin
       Parent := Panel1;
       Align := alClient;
       //SetActivateDropAccept(True); // or via property, like ActivateDropAccept := True;
       // Replaced by:
       OnDropFiles := DoOnDropFiles;  // Symtax: Mode Delphi
       // Working with OnDropFiles doesn't require DragAcceptFiles any longer,
       // but does require AllowDropFiles:= True
   end;
   AllowDropFiles:= True;  // Lazarus (Delphi does not know this property)
   //DragAcceptFiles( Handle, True );
   //DragAcceptFiles( Application.Handle, True );
   //DragAcceptFiles( MyCustomListView1.Handle, True );
   //DragAcceptFiles( Panel1.Handle, True );  // Test, as this is the owner of the listview
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   MyCustomListView1.Free;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of String );
begin
  ShowMessage('MainForm -  FormDropFiles');
end;

procedure TForm1.WndProc(var Message: TMessage);
begin
  with Message do begin
    Case Msg Of
      WM_CREATE : ShowMessage('MyCustomListViewWndProc: received WM_CREATE');
      WM_DROPFILES : ShowMessage('MainForm WndProc: received WM_DROPFILES');
    end;
  end;
  inherited;
end;

procedure TForm1.WMDropFiles(var Msg: TMessage);
begin
  //---------------------------------------------------
  // ------This is the only that seems to work -------
  //---------------------------------------------------
  ShowMessage('MainForm -  WMDropFiles');
end;


//===============================================================================

procedure TMyCustomListView.DoOnDropFiles(Sender: TObject;const FileNames: array of String);
begin
  ShowMessage('MyCustomListView -  DoOnDropFiles');
end;

procedure TMyCustomListView.WMDropFiles(var Msg: TMessage);
begin
  ShowMessage('MyCustomListView -  WMDropFiles');
end;

procedure TMyCustomListView.WndProc(var Message: TMessage);
var wmmesg: String;
begin
  with Message do begin
    Case Msg Of
     // WM_CREATE : ShowMessage('MyCustomListViewWndProc: received WM_CREATE');
      WM_DROPFILES : ShowMessage('MyCustomListView WndProc: received WM_DROPFILES');
    end;
  end;
  inherited;
end;

constructor TMyCustomListView.Create(AOwner: TComponent);
var aWinCtl: TWinControl; aWndHandle: HWND;
begin
  inherited Create(AOwner);
  aWinCtl := TWinControl( AOwner );
  aWndHandle := aWinCtl.Handle;
  DragAcceptFiles( aWndHandle, True );
end;

destructor TMyCustomListView.Destroy;
begin
  inherited Destroy;
end;

procedure TMyCustomListView.SetActivateDropAccept(Value: Boolean);
begin
  DragAcceptFiles( Handle, True );
end;


end.
